<h1>{{ 'scheduling.diagram.headline' | translate }}</h1>

<div class="button-container">
  <button class="btn btn-primary" (click)="pagingService.submit()" type="button">
    <fa-icon [icon]="faCheck"></fa-icon>
    {{ 'paging.diagram.check' | translate }}
  </button>
  <button class="btn btn-secondary" (click)="pagingService.clear()" type="button">
    <fa-icon [icon]="faRecycle"></fa-icon>
    {{ 'paging.diagram.clearAll' | translate }}
  </button>
  <button class="btn btn-secondary" (click)="transpose()" type="button">
    {{ 'paging.diagram.transpose' | translate }}
  </button>
  <button class="btn btn-secondary" (click)="generateNewCallList()" type="button">
    {{ 'paging.diagram.newCallList' | translate }}
  </button>
  <button type="button" class="btn btn-secondary" (click)="toggleManual()">
    <fa-icon [icon]="faQuestion"></fa-icon>
    {{ 'paging.basics.manual' | translate }}
  </button>
</div>

<div class="tablediv">
  <table class="{{ tableclass }} paging-diagram">
    <caption class="d-none">
      Paging Diagram
    </caption>
    <tr>
      <th scope="col">{{ 'paging.basics.page' | translate }}</th>
      <th scope="col" *ngIf="pagingService.doubleFlagAlgorithms.includes(pagingService.diagram.strategy)">R/W</th>
      <th scope="col" *ngFor="let frame of pagingService.diagram.diagram[0]; let i = index">
        f<sub>{{ i + 1 }}</sub>
      </th>
      <th scope="col">{{ 'paging.basics.pageFaults' | translate }}</th>
      <th scope="col" *ngIf="pagingService.doubleFlagAlgorithms.includes(pagingService.diagram.strategy)">
        {{ 'paging.basics.writeBack' | translate }}
      </th>
    </tr>
    <tr *ngFor="let row of pagingService.diagram.diagram; let i = index" [class.gray-table]="i % 2 == 0">
      <td style="border-left: none">
        <strong>{{ pagingService.diagram.callList[i] }}</strong>
      </td>
      <td
        style="text-align: center"
        *ngIf="pagingService.doubleFlagAlgorithms.includes(pagingService.diagram.strategy)"
      >
        {{ pagingService.diagram.rwList[i] ? 'w' : 'r' }}
      </td>
      <td
        *ngFor="let datum of row; let j = index"
        class="{{
          pagingService.flagAlgorithms.includes(pagingService.diagram.strategy)
            ? pagingService.doubleFlagAlgorithms.includes(pagingService.diagram.strategy)
              ? 'clockCell'
              : 'bigCell'
            : 'smallCell'
        }}"
      >
        <input
          (change)="pagingService.updateDatumTarget(i, j, $event.target)"
          [value]="valueCheck(datum.page)"
          max="{{ pagingService.pageCount }}"
          min="1"
          placeholder="{{ valueCheck(pagingService.placeholderDiagram[i][j].page) }}"
          type="number"
          class="form-control {{ getTableDatumClass(i, j) }}"
          [style]="pagingService.doubleFlagAlgorithms.includes(pagingService.diagram.strategy) ? 'width: 100%' : ''"
        />
        <input
          *ngIf="
            pagingService.flagAlgorithms.includes(pagingService.diagram.strategy) &&
            !pagingService.doubleFlagAlgorithms.includes(pagingService.diagram.strategy)
          "
          (change)="pagingService.updateFlag(i, j, checkFlagTarget($event.target))"
          [value]="valueCheck(datum.flag)"
          min="0"
          max="99"
          class="form-control flag {{ getTableDatumClass(i, j) }}"
          placeholder="{{ valueCheck(pagingService.placeholderDiagram[i][j].flag, true) }}"
          type="number"
        />
        <div *ngIf="pagingService.doubleFlagAlgorithms.includes(pagingService.diagram.strategy)">
          <input
            (change)="pagingService.toggleFlag(i, j)"
            type="checkbox"
            value=""
            id="flexCheck.{{ i }}.{{ j }}"
            [attr.checked]="pagingService.getBoolFlag(i, j) ? '' : null"
            class="form-check-input{{ getDoubleFlagClass(i, j) }}"
          />
          <label class="form-check-label" for="flexCheck.{{ i }}.{{ j }}" style="padding-right: 1em">
            &nbsp;R={{ pagingService.getBoolFlag(i, j) ? 1 : 0 }}</label
          >
          <input
            (change)="pagingService.toggleSecFlag(i, j)"
            type="checkbox"
            value=""
            id="flexCheck2.{{ i }}.{{ j }}"
            [attr.checked]="pagingService.getBoolFlag(i, j, true) ? '' : null"
            class="form-check-input{{ getDoubleFlagClass(i, j) }}"
          />
          <label class="form-check-label" for="flexCheck2.{{ i }}.{{ j }}">
            &nbsp;M={{ pagingService.getBoolFlag(i, j, true) ? 1 : 0 }}</label
          >
        </div>
      </td>
      <td>
        <div class="form-check">
          <input
            class="form-check-input{{ getPageFaultsClass(i) }}"
            type="checkbox"
            value=""
            id="flexCheck{{ i }}"
            (click)="updatePageFaults(i)"
            [attr.checked]="getPageFaultState(i) ? '' : null"
          />
          <label class="form-check-label" for="flexCheck{{ i }}"> &nbsp;{{ getPageFaults(i) }} </label>
        </div>
      </td>
      <td *ngIf="pagingService.doubleFlagAlgorithms.includes(pagingService.diagram.strategy)">
        <div class="form-check">
          <input
            class="form-check-input{{ getWriteBackClass(i) }}"
            type="checkbox"
            value=""
            id="flexCheckWB{{ i }}"
            (click)="updateWriteBack(i)"
            [attr.checked]="getWriteBackState(i) ? '' : null"
          />
        </div>
      </td>
    </tr>
  </table>
</div>
<div *ngIf="showManual" class="alert alert-dismissible alert-dark">
  <button type="button" class="btn-close" (click)="toggleManual()"></button>
  <h4 class="alert-heading">{{ 'paging.basics.manual' | translate }}</h4>
  <p>{{ 'paging.diagram.manualOne' | translate }}</p>
  <p>{{ 'paging.diagram.manualTwo' | translate }}</p>
  <p>{{ 'paging.diagram.manualThree' | translate }}</p>
</div>
